VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "vtipcolIFace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'///////////////////////////////
'//VTIPCOL.VTIPCOLIFACE
'//By:     Alex Keene
'//Email:  foo@subnetwork.com
'///////////////////////////////

Public TT_HOVER_TIMER     As Boolean '//unload tip on mouseout
Public USER_ABORTED As Boolean

Public Function Init()
TT_HOVER_TIMER = False
End Function

Public Function SpawnVTip(LV_Hwnd As Long, FRM_Hwnd As Long, LV_ClientIndex As Long, NumberOfCols As Long, XBuff As Long, YBuff As Long) As String()

SpawnVTip = LoadVTip(frmTp_3D, LV_Hwnd, FRM_Hwnd, LV_ClientIndex, NumberOfCols, XBuff, YBuff)

End Function



Private Function LoadVTip(FormObject As Form, LV_Hwnd As Long, FRM_Hwnd As Long, _
                         LV_ClientIndex As Long, NumberOfCols As Long, _
                         XBuff As Long, YBuff As Long) As String()

Dim lpR As RECT
Dim lvcR As RECT
Dim tbR As RECT
Dim lvR As POINTAPI
Dim r As Long
Dim TopOffset As Long
Dim LeftOffset As Long
Dim LIHeight As Long
Dim LIWidth As Long
Dim j As Integer
Dim LeftOffSetIncrement As Double

'//Get X/Y Coords of LI
'//r = SendMessage(lv_hwnd, LVM_GETITEMPOSITION, LV_ClientIndex, lpR)

'//Get LV Coords
r = ClientToScreen(LV_Hwnd, lvR)

'//Get Size of LI Rect
r = SendMessage(LV_Hwnd, LVM_GETITEMRECT, LV_ClientIndex, lpR)
LIHeight = lpR.Bottom - lpR.Top

'//Get the Client area of the LV, will be different from LVM_GETITEMRECT if
'//Horizontal scrollbars are used
r = GetClientRect(LV_Hwnd, lvcR)

'//Use LIWidth = lpR.Right - lpR.Left for True length, including area off screen
LIWidth = lvcR.Right - lvcR.Left

TopOffset = YBuff + lvR.Y + lpR.Top - LIHeight

LeftOffset = XBuff + lvR.X + lpR.Left

'//Get The Column order Array
NumCols = NumberOfCols
ReDim ColOrd(0 To NumCols) As Long
ReDim ColWid(0 To NumCols) As Integer
ReDim ColTxt(0 To NumCols) As String

r = SendMessage(LV_Hwnd, LVM_GETCOLUMNORDERARRAY, NumCols, ColOrd(0))

'//Iterate thru the columns
For j = 0 To NumCols - 1

    '//Get the width of the column (in twips) in the current order
    r = SendMessage(LV_Hwnd, LVM_GETCOLUMNWIDTH, ColOrd(j), 0)
    ColWid(ColOrd(j)) = Int((r * Screen.TwipsPerPixelX) / 10 * 10)
    
    '//Get the Item Text
    Dim LV As LVITEM
    
    With LV
        .mask = LVIF_TEXT
        .iSubItem = ColOrd(j)
        .cchTextMax = 255
        .pszText = Space$(255)
    End With

    r = SendMessage(LV_Hwnd, LVM_GETITEMTEXT, LV_ClientIndex - 1, LV)
    ColTxt(ColOrd(j)) = Left((LV.pszText), Len(LV.pszText) - 1)
Next

'//Get the Font of the LV
Dim fDc
fDc = SendMessage(LV_Hwnd, WM_GETFONT, 0, 0)

With FormObject
    
    '//set the width of the 1st textbox to the 1st LI
    LeftBuff = Int((LeftOffset / Screen.TwipsPerPixelX) / 10 * 10)
    .txtEd(0).Left = LeftBuff
    .txtEd(0).Width = ColWid(ColOrd(0))
    
    .txtEd(0).Text = ColTxt(ColOrd(0))
    .txtEd(0).Height = LIHeight * Screen.TwipsPerPixelY
    .txtEd(0).Tag = ColOrd(0)
    .txtEd(0).ToolTipText = "Original: " & ColTxt(ColOrd(0))
    
    '//Get the size of the Textbox to ensure that the lower edge
    '//is drawn on screen
    r = GetWindowRect(.txtEd(0).hwnd, tbR)
    
    '//Set the Font
    If Not IsNull(fDc) Then r = SendMessage(.txtEd(0).hwnd, WM_SETFONT, fDc, True)
    
    '//Save the Left of the next textbox
    LeftBuff = LeftBuff + ColWid(ColOrd(0))
    
    '//Create textboxes for each other column
    For j = 1 To NumCols - 1
    
        Load .txtEd(j)
        If Not IsNull(fDc) Then r = SendMessage(.txtEd(j).hwnd, WM_SETFONT, fDc, True)
        
        .txtEd(j).Left = LeftBuff
        .txtEd(j).Width = ColWid(ColOrd(j))
        .txtEd(j).Height = LIHeight * Screen.TwipsPerPixelY
        .txtEd(j).Visible = True
        .txtEd(j).Text = ColTxt(ColOrd(j))
        
        '//Set tag to ordinal column index/order
        .txtEd(j).Tag = ColOrd(j)
        .txtEd(j).TabIndex = j
        .txtEd(j).ToolTipText = "Original: " & ColTxt(ColOrd(j))
        
        LeftBuff = LeftBuff + ColWid(ColOrd(j))
        
    Next
    
    '//Set the popup height to the height of the textboxes
    '//remove this line to set it to the height of the LI
    LIHeight = tbR.Bottom - tbR.Top
    
    For r = 0 To 2
        .cmdJ(r).Left = LeftBuff + r * 253
        .cmdJ(r).Height = LIHeight * Screen.TwipsPerPixelY
        .cmdJ(r).TabIndex = j + (2 * r)
    Next
   
    '//Recalc the width of the window to the total width of the columns
    '//in addition to the 2 buttons
    LeftBuff = (LeftBuff + 253 + 253 + 253) / Screen.TwipsPerPixelX

    '//Load the Window
    
    SetWindowPos FormObject.hwnd, HWND_TOP, LeftOffset, TopOffset, LeftBuff, LIHeight, f
    
    .tOutTimer.Enabled = TT_HOVER_TIMER

    ReDim DataOut(0 To NumCols) As String

    .Show 1
    
    '//Reasign the Array set by the form to the Function output
    LoadVTip = DataOut
    
    '//Set the Aborted by user flag
    USER_ABORTED = USERABORTED
End With

End Function

